=== debian/changelog ===
d2x-rebirth (0.57.3+repack-1) unstable; urgency=low

  * Initial release (Closes: #709660).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 25 May 2013 08:07:39 +1000
