=== debian/changelog ===
d2x-rebirth (0.58.1-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Avoid defining objects twice; this allows building with GCC 10.
    Closes: #966188.

 -- Stephen Kitt <skitt@debian.org>  Sun, 02 Aug 2020 11:43:10 +0200

d2x-rebirth (0.58.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Allow building with Python 3. Closes: #947559.

 -- Stephen Kitt <skitt@debian.org>  Sun, 02 Feb 2020 18:18:43 +0100

d2x-rebirth (0.58.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch from Markus Koschany to fix FTBFS with libphysfs 3.0.1.
    (Closes: #881589)
  * Stop manually setting xz compression, that is now the default.

 -- Adrian Bunk <bunk@debian.org>  Sat, 09 Dec 2017 16:16:38 +0200

d2x-rebirth (0.58.1-1) unstable; urgency=low

  * New upstream release [July 2013].
    + no longer repack orig.tar as there is no need to remove any files.
  * "XS-Autobuild: yes" + autobuild, thanks to Philipp Kern.
  * Patchworks:
    - dropped "LDFLAGS.patch".
    + updated "debian.patch".

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 04 Aug 2013 05:40:30 +1000
