=== debian/watch ===
version=3

opts=\
dversionmangle=s/\+(?:dfsg|repack)//\
 https://github.com/dxx-rebirth/dxx-rebirth/tags \
  .*/archive/(\d[-\d\.]+)-d2x\.tar\.gz
