=== debian/changelog ===
d2x-rebirth (0.60~git20250524-1) unstable; urgency=low

  * New GIT snapshot.
     - fix build with recent GCC/G++ (Closes: #1057552)
     - fix static noise during audio playback in Descent 2 (Closes: #1069996)
  * Build against SDL2 (Closes: #1038184)
  * d/control:
     + d2x-rebirth: add Depends on descent2-data | descent2-demo-data |
                                   game-data-packager
     + set S-V to 4.7.2.
  * Install svg icons instead of old blurry xpm files.
  * Install AppStream metainfo.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 25 Aug 2025 09:39:10 +0200
