=== debian/control ===
Source: d2x-rebirth
Section: non-free/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
               libglu1-mesa-dev,
               libphysfs-dev,
               libpng-dev,
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               scons
XS-Autobuild: yes
Homepage: http://www.dxx-rebirth.com
Vcs-Browser: https://salsa.debian.org/twolife/dxx-rebirth
Vcs-Git: https://salsa.debian.org/twolife/dxx-rebirth.git

Package: d2x-rebirth
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, descent2-data | descent2-demo-data | game-data-packager
Recommends: timidity, freepats
Description: port of the 1996 classic game Descent 2: Counterstrike
 DXX-Rebirth is a Source Port of the Descent & Descent ][ Engines and
 provides classical Gameplay combined with OpenGL graphics and effects,
 a bunch of improvements and new features.
 .
 This package provides the engine to play "Descent 2: Counterstrike"
 .
 Original game data is needed to play this game.
